/* H8Sci.c */

#include <machine.h>
#include "iodefine.h"
#include "H8Sci.h"

/* for Hew Emulator Debug */
#ifdef HEW_MONITOR
# include <stdio.h>
#endif


/* ꂼ 2^n ̒lɂ邱 */
#define TX_BUFFER_SIZE (0x100)
#define RX_BUFFER_SIZE (0x100)

/* Mobt@ */
unsigned char RXBUF[SCIMAX][RX_BUFFER_SIZE];
unsigned char TXBUF[SCIMAX][TX_BUFFER_SIZE];

/* obt@|C^ */
unsigned int next_in_rx[SCIMAX],next_out_rx[SCIMAX] ;
unsigned int next_in_tx[SCIMAX],next_out_tx[SCIMAX] ;

/* PoCgM[`̃e[u */
/* ̒lA͂OŐ푗M */
/* ̒l͊gMXe[^XiFIFO lߍ݉\Ԃĵɗ\ */
typedef int (*scisendfunc)(unsigned char dt) ;
const scisendfunc TXFUNCTBL[SCIMAX] = { 
	H8Sci0TxOne ,
	H8Sci1TxOne ,
} ;


/*
	obt@f[^邩H
*/
int SciEmpty(int port) 
{
	return (next_in_tx[port] == next_out_tx[port]) ;
}


/*-------------------------------------------------------------------------------*/
/*
	obt@ɂf[^PoCgMiobNOEhŁj
*/
void SciSend(int port) 
{
	int res ;
	unsigned char c,savesreg;
	if (next_in_tx[port] == next_out_tx[port]) { /* NOP if no data */
    	return ;
  	}

	savesreg = get_imask_ccr() ; // 荞݃}XN̎Q
    set_imask_ccr(1); /* ֎~ */
    c = TXBUF[port][next_out_tx[port]] ;
	/* 1 oCgM[`̌Ăяoie[uj*/
	do {
		res = TXFUNCTBL[port](c) ;
		/* ɑMł */
		if (res >= 0) {
		    next_out_tx[port] = (next_out_tx[port]+1) & (TX_BUFFER_SIZE-1);
		}
	} while ((res > 0) && (next_in_tx[port] != next_out_tx[port])) ; // res>0 : FIFO ɋ󂫂
	set_imask_ccr(savesreg) ;
}

/*-------------------------------------------------------------------------------*/
/*
	Mobt@ɂPLN^lߍރ[`
*/
#ifndef HEW_MONITOR
int SciPutc(int port,unsigned char c) 
{
	unsigned int t ;
	unsigned char savesreg;

	// o͂̂ĂƂ Port ɔ͈͊Ow
	if ((port < 0) || (port >= SCIMAX)) {
		return 0 ;
	}

	savesreg = get_imask_ccr() ; // 荞݃}XN̎Q
    set_imask_ccr(1); /* ֎~ */
	t = next_in_tx[port] ;
	next_in_tx[port] = (next_in_tx[port] + 1) & (TX_BUFFER_SIZE-1) ;
	if (next_in_tx[port] == next_out_tx[port]) { // Buffer full !!
    	next_in_tx[port] = t ;
		set_imask_ccr(savesreg) ;
    	return -1 ;			     
  	} else {
    	TXBUF[port][t] = c;
		set_imask_ccr(savesreg) ;
    	return 0 ;
  	}
}
#else
int SciPutc(int port,unsigned char c) 
{
	// o͂̂ĂƂ Port  -1 w
	if (port < 0) {
		return 0 ;
	}

	fputc(c,stdout) ;
	return 0 ;
}
#endif

/*-------------------------------------------------------------------------------*/
/*
	Mobt@PLN^o[`
*/
#ifndef HEW_MONITOR
int SciGetc(int port) 
{
	unsigned char c,savesreg;

	/*  Port ɔ͈͊Ow肳ꂽ -1 (NO DATA) */
	if ((port < 0) || (port >= SCIMAX)) {
		return -1 ;
	}

	savesreg = get_imask_ccr() ; // 荞݃}XN̎Q
    set_imask_ccr(1); /* ֎~ */
	/* wait until receive */
	if (next_in_rx[port] == next_out_rx[port]) {
		set_imask_ccr(savesreg) ;
		return -1 ; /* NO DATA */
	}
	c = RXBUF[port][next_out_rx[port]] ;
	next_out_rx[port] = (next_out_rx[port] + 1)&(RX_BUFFER_SIZE-1);
	set_imask_ccr(savesreg) ;
	return (int)c ;
}
#else
int SciGetc(int port) 
{
	return fgetc(stdin) ;
}
#endif
/*-------------------------------------------------------------------------------*/
/*
	M荞݂Ă΂PoCgM[`
	RXBUF[] ɋlߍ
*/
void SciRxOne(int port,unsigned char rxd) 
{
	unsigned int t ;

	t = next_in_rx[port] ;
	next_in_rx[port] = (next_in_rx[port] + 1) & (RX_BUFFER_SIZE-1) ;
	if (next_in_rx[port] == next_out_rx[port]) { // Buffer full !!
		next_in_rx[port] = t ;
	} else {
		RXBUF[port][t] = rxd ;
	}
}
/*-------------------------------------------------------------------------------*/
/*
	SCI0  1 oCgM
*/
int H8Sci0TxOne( unsigned char dt ){
    if ( SCI0.SSR.BIT.TDRE == 1 ){
        SCI0.TDR = dt ;
        SCI0.SSR.BIT.TDRE = 0 ;
        return 0 ;
    } else {
        return -1 ;
    }
}
/*-------------------------------------------------------------------------------*/
/*
	SCI1  1 oCgM
*/
int H8Sci1TxOne( unsigned char dt ){
    if ( SCI1.SSR.BIT.TDRE == 1 ){
        SCI1.TDR = dt ;
        SCI1.SSR.BIT.TDRE = 0 ;
        return 0 ;
    } else {
        return -1 ;
    }
}
/*-------------------------------------------------------------------------------*/
#pragma interrupt ( H8Sci0RxDI )
void H8Sci0RxDI(void){ /* rbhOM荞 */

    unsigned char rxs ;
    unsigned char rxd ;

    rxs = SCI0.SSR.BYTE ;
    rxd = SCI0.RDR ;
    SCI0.SSR.BYTE = 0x80 ; /* G[rbg̃NA */
    if (( rxs & 0x40 ) != 0 ){ /* Mf[^LH */
        SciRxOne( 0, rxd ) ; 
    }
}
/*-------------------------------------------------------------------------------*/
#pragma interrupt ( H8Sci1RxDI )
void H8Sci1RxDI(void){ /* rbhPM荞 */

    unsigned char rxs ;
    unsigned char rxd ;

    rxs = SCI1.SSR.BYTE ;
    rxd = SCI1.RDR ;
    SCI1.SSR.BYTE = 0x80 ; /* G[rbg̃NA */
    if (( rxs & 0x40 ) != 0 ){ /* Mf[^LH */
        SciRxOne( 1, rxd ) ; 
    }
}
/*-------------------------------------------------------------------------------*/
#pragma interrupt ( H8Sci0RxEI )
void H8Sci0RxEI(void){ /* rbhO(422)MG[荞 */

    unsigned char rxs ;
    unsigned char rxd ;

    rxs = SCI0.SSR.BYTE ;
    rxd = SCI0.RDR ;
    SCI0.SSR.BYTE = 0x80 ; /* G[rbg̃NA */
    if (( rxs & 0x40 ) != 0 ){ /* Mf[^LH */
        SciRxOne( 0, rxd ) ; /* 2002/04/07 Nch701(422C)̎M */
    }
}
/*-------------------------------------------------------------------------------*/
#pragma interrupt ( H8Sci1RxEI )
void H8Sci1RxEI(void){ /* rbhPMG[荞 */

    unsigned char rxs ;
    unsigned char rxd ;

    rxs = SCI1.SSR.BYTE ;
    rxd = SCI1.RDR ;
    SCI1.SSR.BYTE = 0x80 ; /* G[rbg̃NA */
    if (( rxs & 0x40 ) != 0 ){ /* Mf[^LH */
        SciRxOne( 1, rxd ) ; /* 2002/04/07 BUS(232C) ̎M */
    }
}

/*-------------------------------------------------------------------------------*/
/* ȉ͏p[` */
/*-------------------------------------------------------------------------------*/
void Start_H8Sci( void ){
	int i ;

    /* SCI0   */
    SCI0.SMR.BIT.CA   = 0 ; // [h
    SCI0.SMR.BIT.CHR  = 0 ; // f[^Wrbg
    SCI0.SMR.BIT.PE   = 0 ; // -------------- peB -------
    SCI0.SMR.BIT.OE   = 1 ; // peB
    SCI0.SMR.BIT.STOP = 0 ; // XgbvrbgP
    SCI0.SMR.BIT.MP   = 0 ; // }`vZbT@\̋֎~
    
    SCI0.SCR.BIT.TIE  = 0 ; // Mobt@GveBŊ֎~
    SCI0.SCR.BIT.RIE  = 1 ; // MAMG[LŊ
    SCI0.SCR.BIT.TE   = 1 ; // M싖
    SCI0.SCR.BIT.RE   = 1 ; // M싖
    SCI0.SCR.BIT.MPIE = 0 ; // }`vZbT֎~
    SCI0.SCR.BIT.TEIE = 0 ; // MI֎~
    SCI0.SCR.BIT.CKE  = 0 ; // SCK[q͔ėpo͒[qƂĎgp
    
    /* SCI0.SSR.BIT.TDRE = 0 ; // Tx Data Empty Reset
       sƒɃS~PoCgMĂ܂ */
    SCI0.SSR.BIT.RDRF = 0 ; // Rx Data Reset
    SCI0.SSR.BIT.ORER = 0 ; // Error Reset
    SCI0.SSR.BIT.FER  = 0 ; // Error Reset
    SCI0.SSR.BIT.PER  = 0 ; // Error Reset
    // SCI0.SSR.BIT.TEND = x ; // Read Only
    // SCI0.SSR.BIT.MPB  = x ; // Read Only
    SCI0.SSR.BIT.MPBT = 0 ;
    /* SCI0  ܂ */
    
    /* SCI1   */
    SCI1.SMR.BIT.CA   = 0 ; // [h
    SCI1.SMR.BIT.CHR  = 0 ; // f[^Wrbg
    SCI1.SMR.BIT.PE   = 0 ; // ------------- peB ---------
    SCI1.SMR.BIT.OE   = 1 ; // peB
    SCI1.SMR.BIT.STOP = 0 ; // XgbvrbgP
    SCI1.SMR.BIT.MP   = 0 ; // }`vZbT@\̋֎~
    
    SCI1.SCR.BIT.TIE  = 0 ; // Mobt@GveBŊ֎~
    SCI1.SCR.BIT.RIE  = 1 ; // MAMG[LŊ
    SCI1.SCR.BIT.TE   = 1 ; // M싖
    SCI1.SCR.BIT.RE   = 1 ; // M싖
    SCI1.SCR.BIT.MPIE = 0 ; // }`vZbT֎~
    SCI1.SCR.BIT.TEIE = 0 ; // MI֎~
    SCI1.SCR.BIT.CKE  = 0 ; // SCK[q͔ėpo͒[qƂĎgp
    
    SCI1.SSR.BYTE = 0;
    /* SCI1  ܂ */    

	SciFlushBuf() ;
}

/*-------------------------------------------------------------------------------*/
/* obt@|C^̏ */
void SciFlushBuf(void)
{
	int i ;

	for (i = 0;i < SCIMAX;i++) {
		next_in_rx[i]  = 0 ;
		next_out_rx[i] = 0 ;
		next_in_tx[i]  = 0 ;
		next_out_tx[i] = 0 ;
	}
}

/*-------------------------------------------------------------------------------*/
void Init_H8Sci(void)
{    
    /* SCI0   */
    SCI0.SMR.BIT.CA   = 0 ; // [h
    SCI0.SMR.BIT.CHR  = 0 ; // f[^Wrbg
    SCI0.SMR.BIT.PE   = 0 ; // -------------- peB -------
    SCI0.SMR.BIT.OE   = 1 ; // peB
    SCI0.SMR.BIT.STOP = 0 ; // XgbvrbgP
    SCI0.SMR.BIT.MP   = 0 ; // }`vZbT@\̋֎~

    SCI0.SMR.BIT.CKS  = 0 ; // {[[gWFl[^̃NbN̓
    //SCI0.BRR = 0x19;         /* 19200bps@16MHz            */
#ifdef MONDEBUG
    SCI0.BRR = 0x13;           /* 38400bps@25MHz            */
#else
    SCI0.BRR = 0x13;           /* 38400bps@25MHz            */
#endif

    //SCI0.BRR = 95 ; // ӁPSDVSTUl̏ꍇ̂PQOO{[
    
    SCI0.SCR.BIT.TIE  = 0 ; // Mobt@GveBŊ֎~
    SCI0.SCR.BIT.RIE  = 0 ; // MAMG[LŊ֎~
    SCI0.SCR.BIT.TE   = 1 ; // M싖
    SCI0.SCR.BIT.RE   = 0 ; // M֎~
    SCI0.SCR.BIT.MPIE = 0 ; // }`vZbT֎~
    SCI0.SCR.BIT.TEIE = 0 ; // MI֎~
    SCI0.SCR.BIT.CKE  = 0 ; // SCK[q͔ėpo͒[qƂĎgp

    /* SCI0.SSR.BIT.TDRE = 0 ; // Tx Data Empty Reset
       sƒɃS~PoCgMĂ܂ */
    SCI0.SSR.BIT.RDRF = 0 ; // Rx Data Reset
    SCI0.SSR.BIT.ORER = 0 ; // Error Reset
    SCI0.SSR.BIT.FER  = 0 ; // Error Reset
    SCI0.SSR.BIT.PER  = 0 ; // Error Reset
    // SCI0.SSR.BIT.TEND = x ; // Read Only
    // SCI0.SSR.BIT.MPB  = x ; // Read Only
    SCI0.SSR.BIT.MPBT = 0 ;
    /* SCI0  ܂ */
    
    /* SCI1   */
    SCI1.SMR.BIT.CA   = 0 ; // [h
    SCI1.SMR.BIT.CHR  = 0 ; // f[^Wrbg
    SCI1.SMR.BIT.PE   = 0 ; // ------------- peB ---------
    SCI1.SMR.BIT.OE   = 1 ; // peB
    SCI1.SMR.BIT.STOP = 0 ; // XgbvrbgP
    SCI1.SMR.BIT.MP   = 0 ; // }`vZbT@\̋֎~

    SCI1.SMR.BIT.CKS  = 0 ; // {[[gWFl[^̃NbN̓
#ifdef MONDEBUG
    SCI1.BRR = 0x13;           /* 38400bps@25MHz            */
#else
    SCI1.BRR = 0x06;           /* 115200bps@25MHz            */
#endif
    
    SCI1.SCR.BIT.TIE  = 0 ; // Mobt@GveBŊ֎~
    SCI1.SCR.BIT.RIE  = 0 ; // MAMG[LŊ֎~
    SCI1.SCR.BIT.TE   = 1 ; // M싖
    SCI1.SCR.BIT.RE   = 0 ; // M֎~
    SCI1.SCR.BIT.MPIE = 0 ; // }`vZbT֎~
    SCI1.SCR.BIT.TEIE = 0 ; // MI֎~
    SCI1.SCR.BIT.CKE  = 0 ; // SCK[q͔ėpo͒[qƂĎgp
    
    SCI1.SSR.BYTE = 0;
}
/*-------------------------------------------------------------------------------*/
