/***********************************************************************/
/*                                                                     */
/*  FILE        :hwsetup.c                                             */
/*  DATE        :Sun, Nov 26, 2006                                     */
/*  DESCRIPTION :Hardware Setup file                                   */
/*  CPU TYPE    :H8/3069R                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.5).     */
/*                                                                     */
/***********************************************************************/
                  
#include <machine.h>
#include "iodefine.h"
#include "H8Sci.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void HardwareSetup(void);
#ifdef __cplusplus
}
#endif


void HardwareSetup(void)
{
	// SYSCR : DEFAULT
	//           
	/* Monitor Init for Spartan-Complete */
	set_imask_ccr(1);
	
	/* BUS SIZING CONTROL */
	BSC.ABWCR.BYTE = 0x00 ; // All Address 16 bit 
	
	/* BUS STATE CONTROL */
	BSC.ASTCR.BYTE = 0xFF ; // All Address 3 States
	BSC.WCR.WORD   = 0x0000 ; // All Address NO WAIT
	
	BSC.BRCR.BIT.A23E = 1 ; // A23 is DISABLE(1) = PA4
	BSC.BRCR.BIT.A22E = 1 ; // A22 is DISABLE(1) = PA5
	BSC.BRCR.BIT.A21E = 1 ; // A21 is DISABLE(1) = PA6
	BSC.BRCR.BIT.A20E = 1 ; // A20 is DISABLE(1) = PA7
 	BSC.BRCR.BIT.BRLE = 0 ; // BUS RELEASE DISABLE(0)

	BSC.BCR.BIT.WAITE = 0 ; // /WAIT DISABLE(0)
	
	/* /CS7-4 CONTROL */
	BSC.CSCR.BIT.CS7E = 0 ; // /CS7-4 DISABLE(0)
	BSC.CSCR.BIT.CS6E = 0 ;
	BSC.CSCR.BIT.CS5E = 0 ;
	BSC.CSCR.BIT.CS4E = 0 ;
	
	/* PORT1,2 : ADDRESS BUS */
	P1DDR = 0xFF ;
	P2DDR = 0xFF ;

	/* PORT3,4 : DATABUS */
	P3DDR = 0xFF ;
	P4DDR = 0xFF ;

	/* PORT5 : ADDRESS BUS */
	P5DDR = 0xFF ;
	
	/* PORT6 : BUS CONTROL */
	P6DDR = 0xFF ;
	
	/* PORT7 : ANALOG/DIGITAL PORT */
	// P7DDR is not exist
	
	/* PORT8 : /CS0,1,2,3 and /IRQ0,1,2,3  */
	P8DDR = 0xF0 ;	// 8'b11110000
					// CS    0123   - (1)
					// IRQ    3210  - (0)
	
	/* PORT9 : SIO0,1 and /IRQ4,5 */
	P9DDR = 0xC0 ;	// 8'b11xxxxxx
					// IRQ  54      - (0)
		
	/* PORTA0:/PROGRAM , A1:/INIT , A2:CCLK , A3:DIN , A4:DONE , A5:VCO_INHIBIT */
	/* PORTA6,A7 : ADDRESS BUS */
	PADDR = 0xED ;// ;0x1110 1101; // CCLK,DIN 
	PADR.BIT.B7 = 0 ; // OUTPUT PORT(A7)
	PADR.BIT.B6 = 0 ; // OUTPUT PORT(A6)
	PADR.BIT.B5 = 0 ; // PLL INHIBIT (0=PLL ON) 
	PADR.BIT.B4 = 0 ; // DONE (IN)
	PADR.BIT.B3 = 0 ; // DIN (HI-Z)
	PADR.BIT.B2 = 0 ; // CCLK (HI-Z)
	PADR.BIT.B1 = 0 ; // /INIT
	PADR.BIT.B0 = 1 ; // /PROGRAM
	
	/* PORTB : SIO2 and /CS4,5,6,7 */
	PBDDR = 0xFF ; // ALL OUTPUT (CS4-7 control is BSC.CSCR
	PBDR.BIT.B7 = 0 ; // OUTPUT PORT(A7)
	PBDR.BIT.B6 = 0 ;
	PBDR.BIT.B5 = 0 ;
	PBDR.BIT.B4 = 0 ;
//	PBDR.BIT.B3 = 0 ; // /CS4 OUTPUT
	PBDR.BIT.B2 = 0 ;
	PBDR.BIT.B1 = 0 ;
	PBDR.BIT.B0 = 0 ;
	
	/* H8 SCI INIT */
	Init_H8Sci() ;
	Start_H8Sci() ;

	// SCI0.SCMR.BIT.SMIF = 0 ;
	// SCI0.SCR.BIT.RE    = 1 ;
	// SCI0.SCR.BIT.TE    = 1 ;
}
