/**
	Send Byte to Spartan
**/

#include <machine.h>
#include "iodefine.h"
#include "spartan.h"

/**
	Assert /PROGRAM Line
**/
int enter_progmode(void)
{
	if (INIT == 1) {
		while(INIT == 1) {
			PROG = 0 ; // /PROGRAM <= 0	
		}
		PROG = 1 ; // /PROGRAM <= 1
		while(INIT == 0) {
			// WAIT /INIT is become high
		}
	} else {
		// INIT is LOW
		return -1 ;	
	}	
}

/**
	Program ONE Byte
**/
void send_onebyte(unsigned char b)
{	 	
	unsigned char d7,d6,d5,d4,d3,d2,d1,d0 ;
	
	/** makebits **/
	d7 = b & 1 ;
	b = b >> 1 ;
	d6 = b & 1 ;
	b = b >> 1 ;
	d5 = b & 1 ;
	b = b >> 1 ;
	d4 = b & 1 ;
	b = b >> 1 ;
	d3 = b & 1 ;
	b = b >> 1 ;
	d2 = b & 1 ;
	b = b >> 1 ;
	d1 = b & 1 ;
	b = b >> 1 ;
	d0 = b & 1 ;
	
	/** D0 **/
	DIN  = d0 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D1 **/
	DIN  = d1 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D2 **/
	DIN  = d2 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D3 **/
	DIN  = d3 ;
	CCLK = 1 ;
	CCLK = 0 ;
	
	/** D4 **/
	DIN  = d4 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D5 **/
	DIN  = d5 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D6 **/
	DIN  = d6 ;
	CCLK = 1 ;
	CCLK = 0 ;

	/** D7 **/
	DIN  = d7 ;
	CCLK = 1 ;
	CCLK = 0 ;
}


/**
	Check DONE
**/
int check_done(void)
{
	if (DONE == 1) {
		return 0 ;
	} else {
		return -1 ;
	}
}
