/**
	spartan.h
**/

#ifndef SPARTAN_H
#define SPARTAN_H

/**
    Signal Line To Configure
**/

/* PORTA0:/PROG , A1:/INIT , A2:CCLK , A3:DIN , A4:DONE , A5:VCO_INHIBIT */

#define PROG (PADR.BIT.B0)
#define INIT (PADR.BIT.B1)
#define CCLK (PADR.BIT.B2)
#define DIN  (PADR.BIT.B3)
#define DONE (PADR.BIT.B4)

/**
	Assert /PROGRAM Line
**/
int enter_progmode(void) ;

/**
	Send One Byte
**/
void send_onebyte(unsigned char b) ;

/**
	Check DONE
**/
int check_done(void) ;

#endif /* of SPARTAN_H */